/*
 * MINIGUI - Harbour Win32 GUI library Demo
 *
 * Copyright 2016-19 Verchenko Andrey <verchenkoag@gmail.com>
 * Copyright 2016 Pavel Tsarenko <tpe2@mail.ru>
*/

#include "minigui.ch"
#include "word.ch"

#define  wdWord9TableBehavior 1
#define  wdAutoFitContent     1
//////////////////////////////////////////////////////////////////////////////////////////////
FUNCTION MyWord1Ole( cFileDoc, lActivate, lSave, cTitle, aHead, aDimDbf, aHeadClr, aFooting )
   LOCAL cMsg, nFSize1, aFColor, aFBColor, cFont2, nFSize2
   LOCAL nI, nJ, aClr, aFoot, nFColor, nBColor
   LOCAL oWord, oText, oRange, oTbl, oActive, oMarks
   LOCAL nRowDbf, nColDbf, aRow, xVal, cVal
   DEFAULT aHeadClr := { WHITE, BLUE, 14 } //   

   CursorWait()
   WaitThreadCreate( "  Word ..." )   //   -> WaitThread.prg

   // -------   Word ---------------
   //  Ole  HBWIN.lib
   IF ( oWord := win_oleCreateObject( "Word.Application" ) ) == NIL 
      WaitThreadClose()  //   
      CursorArrow()
      cMsg := "MS Word   !;; "
      cMsg += " [ " + win_oleErrorText() + " ];;"
      MyStop( cMsg , "!" )
      RETURN .F. 
   ENDIF

   oWord:Documents:Add()
   oActive := oWord:ActiveDocument()
   oMarks  := oActive:BookMarks
   oText   := oWord:Selection()

   oWord:Visible := lActivate    //   Word
   WordWindowToForeground(oWord) //  Word   

   // -------    () ------- 
   //  
   //oWord:ActiveDocument:PageSetup:Orientation := wdOrientPortrait
   //  
   oWord:ActiveDocument:PageSetup:Orientation := wdOrientLandscape
   // 
   //oWord:ActiveDocument:PageSetup:LeftMargin := 72.0  //~2.5 
   oWord:ActiveDocument:PageSetup:LeftMargin := 52.0  //~1.5 
   // -------     -------
   //wdApp.Options.CheckSpellingAsYouType = False
   oWord:Options:CheckSpellingAsYouType := .F.

   nRowDbf := LEN(aDimDbf) + 1 + 1  // -    +  +  
   nColDbf := LEN(aDimDbf[1])       // -   

   // http://forums.fivetechsupport.com/viewtopic.php?f=3&t=31073&p=179466&hilit=ole+word#p179466
   // -------   ---------------
   oRange := oText:Document:Content
   oTbl:= oWord:ActiveDocument:Tables:Add(oRange,nRowDbf,nColDbf,wdWord9TableBehavior,wdAutoFitContent)

   // --------   ------------------
   aFColor := aHeadClr[1]
   aFBColor:= aHeadClr[2]
   nFSize1 := aHeadClr[3]
   nFColor  := RGB(aFColor[1],aFColor[2],aFColor[3])    //   
   nBColor  := RGB(aFBColor[1],aFBColor[2],aFBColor[3]) //     
   aFoot := {}
   FOR nI := 1 TO LEN(aHead) 
      aHead[nI] := AtRepl( ";", aHead[nI], CHR(10) ) //CRLF )
      AADD( aFoot, IIF( nI == 2, ":" , "" ) )
   NEXT

   // -------   ---------------
   FOR nI := 1 TO nRowDbf
       IF nI == 1
          aRow := aHead           //  
       ELSEIF nI == nRowDbf       
          aRow := aFoot           //  
       ELSE
          aRow := aDimDbf[nI-1]   //  
       ENDIF

       //    
       FOR nJ := 1 TO LEN(aRow)
          xVal := aRow[nJ]
          cVal := IIF( VALTYPE(xVal) == "D", DTOC(xVal), ALLTRIM( CStr(xVal) ) )
          oTbl:Cell(nI,nJ):Range:Text := cVal
          oTbl:Cell(nI,nJ):Range:Font:Size := nFSize1
          IF VALTYPE(xVal) == "C"
             oTbl:Cell(nI,nJ):Range:ParagraphFormat:Alignment:= wdAlignParagraphLeft
          ELSE
             oTbl:Cell(nI,nJ):Range:ParagraphFormat:Alignment:= wdAlignParagraphCenter
          ENDIF
       NEXT
       DO EVENTS //  !     
   NEXT

   // -------    ---------------
   nI := 1  
   FOR nJ := 1 TO LEN(aHead)           
       oTbl:Cell(nI,nJ):Range:Font:Color := nFColor
       oTbl:Cell(nI,nJ):Range:Font:Size  := nFSize1 
       oTbl:Cell(nI,nJ):Range:ParagraphFormat:Alignment:= wdAlignParagraphCenter
       oTbl:Cell(nI,nJ):Range:Select() //     
       oText:Shading:BackgroundPatternColor := nBColor
       //     
       oText:Cells:VerticalAlignment := wdCellAlignVerticalCenter  
    NEXT
    //oTbl:Rows[1]:Shading:Texture = 650 //     (  )

    // -------   ---------------
    oTbl:Rows[nRowDbf]:Shading:Texture = 250    //    

    oTbl:Cell(nRowDbf,2):Shading:Texture = 250  //   
    oTbl:Cell(nRowDbf,2):Range:Text := ":"
    oTbl:Cell(nRowDbf,2):Range:ParagraphFormat:Alignment:= wdAlignParagraphRight
    oTbl:Cell(nRowDbf,2):Range:Font:Bold = .T. 
    oTbl:Cell(nRowDbf,2):Range:Select() //     

    // ----------    -----------
    FOR nI := 3 TO 7
       oTbl:Cell(nRowDbf,nI):Range:Select() //     
       oText:InsertFormula( "=SUM(ABOVE)", "# ##0,00" ) 
       oText:ParagraphFormat:Alignment:= wdAlignParagraphCenter
    NEXT

   // -------    ------- 
   oText:HomeKey(wdStory)        //   
   oWord:Selection:SplitTable()  //    
   cFont2 := "Times New Roman" ;  nFSize2 := 16
   oText:InsertAfter(cTitle + CHR(13) )
   oText:Font:Name = cFont2
   oText:Font:Size = nFSize2
   oText:Font:Bold = .T.
   oText:ParagraphFormat:Alignment = wdAlignParagraphCenter
   oText:HomeKey(wdStory)        //   
   oText:InsertAfter(" 1" + CHR(13) )
   oText:Font:Size = 12
   oText:Font:Bold = .F.
   aClr := BLUE
   oText:Font:Color = RGB(aClr[1],aClr[2],aClr[3])
   oText:ParagraphFormat:Alignment = wdAlignParagraphRight

   // -------    ------- 
   oText:EndKey(wdStory)  //   
   oText:InsertAfter( CHR(13) + aFooting[1] + REPL("_",20) + aFooting[2]  )
   oText:Font:Size = 12
   aClr := RED
   oText:Font:Color = RGB(aClr[1],aClr[2],aClr[3])
   oText:ParagraphFormat:Alignment = wdAlignParagraphCenter

   oActive:Saved := lSave
   oActive:SaveAs( cFileDoc )  //   
   //oWord:PrintOut(...)

   oWord:WindowState = 1  // MAXIMIZE
   //   -  oWord:Set( "WindowState", 1 )  // MAXIMIZE
   oWord:Selection:HomeKey(6)  //  

   WaitThreadClose()  //     -> WaitThread.prg
   CursorArrow()

   WordWindowToForeground(oWord)

   RETURN NIL

//////////////////////////////////////////////////////////////////////
//  Word   
FUNCTION WordWindowToForeground(oWord)
   LOCAL hWnd, nVer, cCaption, cTitle

   // -------------------      --------------
   hWnd := 0
   nVer := VAL( oWord:Version ) //  Word
   IF nVer > 14  // Word 2010
      hWnd := oWord:ActiveDocument:ActiveWindow:Hwnd 
   ELSE
      //hWnd:=oWord:hwnd -    !
      cCaption := oWord:Windows[1]:Caption  
      cTitle := cCaption + " - MICROSOFT WORD"
      hWnd := FindWindowEx(,,, cTitle )    
      IF hWnd == 0
         cTitle := cCaption + " [  ] - MICROSOFT WORD"
         hWnd := FindWindowEx(,,, cTitle )    
      ENDIF
   ENDIF

   IF hWnd > 0
      ShowWindow( hWnd, 6 ) //SW_MAXIMIZE=3 SW_NORMAL=1 SW_MINIMIZE=6
      INKEYGUI(100)
      ShowWindow( hWnd, 3 ) //SW_MAXIMIZE=3 SW_NORMAL=1 SW_MINIMIZE=6
      BringWindowToTop( hWnd )
      INKEYGUI(100)
   ENDIF
  
   RETURN NIL
